// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.annotatedlineeditor;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import org.apache.log4j.Logger;

/**
 * <p>Abstract EntityListener class.</p>
 *
 * @author p.ciardelli
 * @created 31.08.2009
 * @version 1.0
 */
abstract public class EntityListener implements PropertyChangeListener {
	private static final Logger logger = Logger
			.getLogger(EntityListener.class);

	/* (non-Javadoc)
	 * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
	 */
	/** {@inheritDoc} */
	public void propertyChange(PropertyChangeEvent evt) {
		updateEntity();
	}

	/**
	 * <p>updateEntity</p>
	 */
	abstract protected void updateEntity();
}
